# TODO: re-enable tests (based on pytest)

%if 0%{?fedora}
%global _with_python3 1
# Documentation generation disabled on EPEL because fontawesome-fonts-web
# package, required by python-sphinx_rtd_theme, is dead
%global _with_doc 1
%endif

%if 0%{?rhel}
%global py2_prefix python
%else
%global py2_prefix python2
%endif

%global msrest_min_version 0.4.26
%global msrestazure_min_version 0.4.20

%global srcname azure-sdk

%global common_summary Microsoft Azure SDK for Python
%global common_description This project provides a set of Python packages that make it easy to access the\
Microsoft Azure components such as ServiceManagement, Storage*, and ServiceBus.

Name:           python-%{srcname}
Version:        3.0.0
Release:        2%{?dist}
Summary:        %{common_summary}

# All packages are licensed under the MIT license, except:
# - azure-servicebus
# - azure-servicemanagement-legacy
License:        MIT and ASL 2.0
URL:            https://github.com/Azure/azure-sdk-for-python/
Source0:        https://github.com/Azure/azure-sdk-for-python/archive/azure_%{version}%{?prerelease}/%{srcname}-%{version}%{?prerelease}.tar.gz
# Fix install_requires option, for EPEL especially
Patch0:         %{name}-3.0.0-build.patch
# Install namespace package modules (disabled by default, may be required by
# modules depending on Azure SDK for development)
Patch1:         %{name}-3.0.0-install_nspkgs.patch

BuildRequires:  %{py2_prefix}-setuptools
BuildRequires:  python2-devel
# Needed to build documentation
%if 0%{?_with_doc}
BuildRequires:  %{py2_prefix}-pip
BuildRequires:  %{py2_prefix}-sphinx
BuildRequires:  %{py2_prefix}-sphinx_rtd_theme
%endif
%if 0%{?_with_python3}
BuildRequires:  python3-devel
%endif
BuildArch:      noarch

%description
%{common_description}


%package -n python2-%{srcname}
Summary:        %{common_summary}
Requires:       %{py2_prefix}-msrest >= %{msrest_min_version}
Requires:       %{py2_prefix}-msrestazure >= %{msrestazure_min_version}
Requires:       %{py2_prefix}-pyOpenSSL
Requires:       %{py2_prefix}-requests
%{?python_provide:%python_provide python2-%{srcname}}

%description -n python2-%{srcname}
%{common_description}


%if 0%{?_with_python3}
%package -n python3-%{srcname}
Summary:        %{common_summary}
Requires:       python3-msrest >= %{msrest_min_version}
Requires:       python3-msrestazure >= %{msrestazure_min_version}
Requires:       python3-pyOpenSSL
Requires:       python3-requests
%{?python_provide:%python_provide python3-%{srcname}}

%description -n python3-%{srcname}
%{common_description}
%endif


%if 0%{?_with_doc}
%package doc
Summary:        Documentation for %{name}
Group:          Documentation

%description doc
%{common_description}

This package provides documentation for %{name}.
%endif


%prep
%autosetup -n %{srcname}-for-python-azure_%{version}%{?prerelease} -p0


%build
%py2_build
%{?_with_python3:%py3_build}

# Build documentation
%if 0%{?_with_doc}
%make_build -C doc/ html
rm doc/_build/html/.buildinfo
%endif


%install
%py2_install
%if 0%{?_with_python3}
%py3_install
%endif


%files -n python2-%{srcname}
%doc ChangeLog.rst CONTRIBUTING.md README.rst
%license LICENSE.txt
%{python2_sitelib}/*


%if 0%{?_with_python3}
%files -n python3-%{srcname}
%doc ChangeLog.rst CONTRIBUTING.md README.rst
%license LICENSE.txt
%{python3_sitelib}/*
%endif


%if 0%{?_with_doc}
%files doc
%doc doc/_build/html/
%license LICENSE.txt
%endif


%changelog
* Wed Apr 04 2018 Mohamed El Morabity <melmorabity@fedoraproject.org> - 3.0.0-2
- Add patch to install namespace package modules

* Fri Mar 23 2018 Mohamed El Morabity <melmorabity@fedoraproject.org> - 3.0.0-1
- Update to 3.0.0

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-2.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sun Sep 03 2017 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-2
- Use python2- prefix for Fedora dependencies if possible
- Use parallel make to build documentation

* Thu Jun 15 2017 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-1
- Update to 2.0.0
- Move documentation to a subpackage

* Tue Sep 27 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-0.8.rc6
- Update to 2.0.0rc6

* Thu Jul 21 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-0.7.rc5
- Update to 2.0.0rc5
- Build documentation
- Run tests at build

* Thu May 26 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-0.6.rc4
- Update to 2.0.0rc4

* Sun May 01 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-0.5.rc3
- Update to 2.0.0rc3

* Mon Apr 11 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-0.4.rc2
- Update to 2.0.0rc2

* Fri Mar 25 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-0.3.rc1
- Add missing dependency to enum34 Python module

* Sat Mar 05 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-0.2.rc1
- Update to 2.0.0rc1

* Mon Feb 29 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 2.0.0-0.1.a1
- Update to 2.0.0a1
- Improve macros for Python 3 subpackage

* Mon Feb 08 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 1.0.3-1
- Update to 1.0.3

* Sun Jan 10 2016 Mohamed El Morabity <melmorabity@fedoraproject.org> - 1.0.2-1
- Initial RPM release
